#include<iostream>
#include<vector>
#include<cstring>
#include<algorithm>
using namespace std;
const int MAX_N=1e5+4;
int n;
vector<int>g[MAX_N];
vector<int>rev_g[MAX_N];
int root[MAX_N];
vector<int>adj[MAX_N];
bool used[MAX_N];
vector<int>top;
int m;
int a[MAX_N];
vector<int>comp;
int dp[MAX_N];
void Read()
{
    cin>>n>>m;
    int u,v;
    for(int i=1;i<=m;i++)
    {
        cin>>u>>v;
        g[u].push_back(v);
        rev_g[v].push_back(u);
    }
}
void DFS1(int u)
{
    used[u]=1;
    for(int v:g[u])
    {
        if(!used[v])
        {
            DFS1(v);
        }
    }
    top.push_back(u);
}
void DFS2(int u)
{
    used[u]=1;
    comp.push_back(u);
    for(int v:rev_g[u])
    {
        if(!used[v])
        {
            DFS2(v);
        }
    }
}
void DFS3(int u)
{
    used[u]=1;
    for(int v:adj[u])
    {
        if(!used[v])
        {
            DFS3(v);
        }
    }
    top.push_back(u);
}
void Solve()
{
    for(int i=1;i<=n;i++)
    {
        if(!used[i])
        {
            DFS1(i);
        }
    }
    memset(used,0,sizeof(used));
    reverse(top.begin(),top.end());
    for(int u:top)
    {
        if(!used[u])
        {
            DFS2(u);
            for(int x:comp)
            {
                root[x]=u;
            }
            a[u]=comp.size();
            comp.clear();
        }
    }
    for(int u=1;u<=n;u++)
    {
        for(int v:g[u])
        {
            if(root[v]!=root[u])
            {
                adj[root[u]].push_back(root[v]);
            }
        }
    }
    top.clear();
    memset(used,0,sizeof(used));
    for(int i=1;i<=n;i++)
    {
        if(root[i]==i)
        {
            if(!used[i])
            {
                DFS3(i);
            }
        }
    }
    reverse(top.begin(),top.end());
    dp[top[0]]=a[top[0]];
    for(int u:top)
    {
        for(int v:adj[u])
        {
            dp[v]=max(dp[v],dp[u]+a[v]);
        }
    }
    int ans=-1;
    for(int i=1;i<=n;i++)
    {
        ans=max(ans,dp[i]);
    }
    cout<<ans<<endl;
}
int main ()
{
    Read();
    Solve();
    return 0;
}

