#include<iostream>
using namespace std;
const int MAXN = 5*1e5+7;
int a[MAXN];
int small[4*MAXN];
int bezpyrvo[4*MAXN];
int bezdqsno[4*MAXN];
int whole[4*MAXN];
void build_tree(int l,int r,int ind){
    if(l==r){
        whole[ind]=a[l];
        bezpyrvo[ind]=0;
        bezdqsno[ind]=0;
        small[ind]=0;
    }else{
        int mid=(l+r)/2;
        build_tree(l,mid,2*ind);
        build_tree(mid+1,r,2*ind+1);
        whole[ind]=max(whole[2*ind]+bezpyrvo[2*ind+1],bezdqsno[2*ind]+whole[2*ind+1]);
        bezpyrvo[ind]=max(bezpyrvo[2*ind]+bezpyrvo[2*ind+1],small[2*ind]+whole[2*ind+1]);
        bezdqsno[ind]=max(whole[2*ind]+small[2*ind+1],bezdqsno[2*ind]+bezdqsno[2*ind+1]);
        small[ind]=max(small[2*ind]+bezdqsno[2*ind+1],bezpyrvo[2*ind]+small[2*ind+1]);
        /*cout<<"whole na "<<l<<" do "<<r<<" e "<<whole[ind]<<"\n";
        cout<<"left na "<<l<<" do "<<r<<" e "<<bezpyrvo[ind]<<"\n";
        cout<<"right na "<<l<<" do "<<r<<" e "<<bezdqsno[ind]<<"\n";
        cout<<"small na "<<l<<" do "<<r<<" e "<<small[ind]<<"\n";*/
    }
}
void update(int l,int r,int ql,int ind){
    if(l==r and l==ql){
        whole[ind]=a[l];
    }else{
        int mid=(l+r)/2;
        if(ql<=mid){
            update(l,mid,ql,2*ind);
        }else{
            update(mid+1,r,ql,2*ind+1);
        }
        whole[ind]=max(whole[2*ind]+bezpyrvo[2*ind+1],bezdqsno[2*ind]+whole[2*ind+1]);
        bezpyrvo[ind]=max(bezpyrvo[2*ind]+bezpyrvo[2*ind+1],small[2*ind]+whole[2*ind+1]);
        bezdqsno[ind]=max(whole[2*ind]+small[2*ind+1],bezdqsno[2*ind]+bezdqsno[2*ind+1]);
        small[ind]=max(small[2*ind]+bezdqsno[2*ind+1],bezpyrvo[2*ind]+small[2*ind+1]);
    }
}
int main () {
    int n,m;
    cin>>n>>m;
    for(int i=0;i<n;i++){
        cin>>a[i];
    }
    build_tree(0,n-1,1);
    int x,y;
    cout<<max(max(small[1],bezpyrvo[1]),max(bezdqsno[1],whole[1]))<<"\n";
    for(int i=0;i<m;i++){
        cin>>x>>y;
        a[x-1]=y;
        update(0,n-1,x-1,1);
        cout<<max(max(small[1],bezpyrvo[1]),max(bezdqsno[1],whole[1]))<<"\n";
    }

    return 0;
}
