#include <bits/stdc++.h>
#define endl '\n'
#include "game.h"

using namespace std;

const int maxn = 1e5 + 10;
int n, dp[maxn], used[maxn], mark[maxn];
vector<int> v[maxn], g[maxn];

void dfs(int root){
    if(!v[root].size()){
        dp[root] = 1;
        return;
    }
    used[root] = 1;
    for(int nb : v[root]){
        if(!used[nb]){
            dfs(nb);
            dp[root] += dp[nb];
        }
    }
}

int getCentroid(int root){
    bool is = true;
    int idx = 0;
    used[root] = 1;
    for(int nb : v[root]){
        if(used[nb]) continue;
        if(dp[nb] >= n / 2){
            is = false;
            if(idx == 0 || dp[nb] > dp[idx]){
                idx = nb;
            }
        }
    }
    if(is) return root;
    else return getCentroid(idx);
}
int guess(int N, int a[], int b[]){
    n = N;
    for(int i = 0;i <= N - 2;i++){
        v[a[i]].push_back(b[i]);
        v[b[i]].push_back(a[i]);
    }
    for(int i = 1;i <= n;i++){
        dp[i] = 1;
    }
    dfs(1);
    memset(used, 0, sizeof(used));
    int centroid = getCentroid(1);
    while(1){
        int ver = question(centroid);
        if(ver == centroid) return ver;
        centroid = ver;
    }
}
