#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5+1;
int n, m;
int MAX;
vector<int> v[MAXN];
bool fl[MAXN], fl2[MAXN];

bool Path(int p, int q) {
    if(p == q) return true;
    fl2[p] = 1;
    bool res = false;
    for(int i=0;i<v[p].size();i++) {
        if(!fl2[v[p][i]]) res|= Path(v[p][i], q);
    }
    return res;
}

bool Try(int k, vector<int> tek) {
    for(int i=0;i<tek.size();i++) {
        fill(fl2, fl2+n+1, 0);
        //cout<<"path? "<<k<<" "<<tek[i]<<endl;
        bool res = Path(k, tek[i]);
        fill(fl2, fl2+n+1, 0);
        res|= Path(tek[i], k);
        if(!res) return false;

    }
    return true;
}

void Solve(int k, vector<int> tek) {
    fl[k] = 1;
    //cout<<"k = "<<k<<endl;
    for(int i=0;i<v[k].size();i++) {
        if(fl[v[k][i]]) continue;
        if(Try(v[k][i], tek)) {
            tek.push_back(v[k][i]);
            //cout<<tek.size()<<endl;
            MAX = max(MAX, (int)(tek.size()));
            Solve(v[k][i], tek);
        }
    }
    fl[k] = 0;
}

int main()
{
    cin>>n>>m;
    int i;
    for(i=1;i<=m;i++) {
        int p, q;
        cin>>p>>q;
        v[p].push_back(q);
    }

    int maxx = 0;
    for(i=1;i<=n;i++) {
        fill(fl, fl+n+1, 0);
        MAX = 0;
        Solve(i, vector<int>{i});
        maxx = max(maxx, MAX);
    }

    cout<<maxx<<endl;

    return 0;
}

