#include<bits/stdc++.h>
#define endl '\n'
#include "game.h"
using namespace std;

int const MAXN=1000001;
int utree[MAXN], used[MAXN], vis[MAXN];
vector<int> v[MAXN];

void DFS(int i, int par)
{
    utree[i] = 1;
    int sz = v[i].size();
    for(int j=0;j<sz;j++)
    {
        int nb = v[i][j];
        if(!vis[nb] && nb != par)
        {
            DFS(nb, i);
            utree[i] += utree[nb];
        }
    }
}

int centroid(int ver, int par, int currsz)
{
    int sz = v[ver].size();
    bool state = false;
    for(int i=0;i<sz;i++)
    {
        int nb = v[ver][i];
        if(!vis[nb] && nb != par)
        {
            if(utree[nb] > currsz/2)
            {
                state = true;
                centroid(nb, ver, currsz);
            }
        }
    }
    if(!state) return ver;
}

int answer(int root)
{
    while(true)
    {
        memset(used, 0, sizeof(used));
        DFS(root, 0);
        for(int i=1;i<=)
        int currsz = utree[root];
        int cent = centroid(root, 0, currsz);
        int guess = question(cent);
        vis[cent] = 1;
        vis[guess] = 1;
        if(guess == cent) return guess;
    }
}

int guess (int N, int a[], int b[])
{
    for(int i=0;i<N-1;i++)
    {
        v[a[i]].push_back(b[i]);
        v[b[i]].push_back(a[i]);
    }
    return answer(a[0]);
}
/*
7
6
1 2
2 3
2 4
4 5
4 6
6 7
*/