#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int const MAXN=1000001;
int n, m, a[MAXN];

struct edge
{
    int whole, left, right, middle;
};

edge tree[MAXN];

void make_tree(int idx, int l, int r)
{
    if(l == r)
    {
        tree[idx].whole = a[l];
        tree[idx].left = 0;
        tree[idx].right = 0;
        tree[idx].middle = 0;
        return;
    }
    int mid = (l+r)/2;
    make_tree(idx*2, l, mid);
    make_tree(idx*2+1, mid+1, r);
    tree[idx].whole = max(tree[idx*2].right+tree[idx*2+1].whole, tree[idx*2].whole+tree[idx*2+1].left);
    tree[idx].left = max(tree[idx*2].left+tree[idx*2+1].left, tree[idx*2].middle+tree[idx*2+1].whole);
    tree[idx].right = max(tree[idx*2].right+tree[idx*2+1].right, tree[idx*2].whole+tree[idx*2+1].middle);
    tree[idx].middle = max(tree[idx*2].middle+tree[idx*2+1].right, tree[idx*2].left+tree[idx*2+1].middle);
}

void update(int idx, int l, int r, int pos, int val)
{
    if(l == r)
    {
        tree[idx].whole = val;
        return;
    }
    int mid = (l+r)/2;
    if(mid >= pos) update(idx*2, l, mid, pos, val);
    else update(idx*2+1, mid+1, r, pos, val);
    tree[idx].whole = max(tree[idx*2].right+tree[idx*2+1].whole, tree[idx*2].whole+tree[idx*2+1].left);
    tree[idx].left = max(tree[idx*2].left+tree[idx*2+1].left, tree[idx*2].middle+tree[idx*2+1].whole);
    tree[idx].right = max(tree[idx*2].right+tree[idx*2+1].right, tree[idx*2].whole+tree[idx*2+1].middle);
    tree[idx].middle = max(tree[idx*2].middle+tree[idx*2+1].right, tree[idx*2].left+tree[idx*2+1].middle);
}

void read()
{
    int pos, val;
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
    }
    make_tree(1,1,n);
    cout<<tree[1].whole<<endl;
    for(int i=1;i<=m;i++)
    {
        cin>>pos>>val;
        update(1, 1, n, pos, val);
        cout<<tree[1].whole<<endl;
    }
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
    return 0;
}
