#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int const MAXN=10000001;
int n, m, p[MAXN], used[MAXN], used1[MAXN], k;
vector<int> v[MAXN];
bool state = false;

void print()
{
    for(int i=1;i<=k;i++)
    {
        cout<<p[i]<<" ";
    }
    cout<<endl;
}

void DFS(int i)
{
    used1[i] = 1;
    int sz = v[i].size();
    for(int j=0;j<sz;j++)
    {
        int nb = v[i][j];
        if(!used1[nb])
        {
            used1[nb] = 1;
            DFS(nb);
        }
    }
}

void perm(int pos)
{
    if(pos > k)
    {
        for(int i=1;i<k;i++)
        {
            memset(used1, 0, sizeof(used1));
            DFS(p[i]);
            for(int j=i+1;j<=k;j++)
            {
                if(!used1[p[j]]) return;
            }
        }
        state = true;
        return;
    }
    else
    {
        for(int i=1;i<=n;i++)
        {
            if(!used[i])
            {
                used[i] = 1;
                p[pos] = i;
                perm(pos+1);
                if(state == true) return;
                used[i] = 0;
            }
        }
    }
}

bool check()
{
    state = false;
    memset(used, 0, sizeof(used));
    memset(p, 0, sizeof(p));
    perm(1);
    return state;
}

int bin_search()
{
    int l = 1, r = n;
    while(l <= r)
    {
        k = (l+r)/2;
        if(check()) l = k+1;
        else r = k-1;
    }
    return r;
}

void read()
{
    int x, y;
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
    }
    cout<<bin_search()<<endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
    return 0;
}
