#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int const MAXN=16;
int n, m, p[MAXN], used[MAXN], k, possible[MAXN][MAXN];
vector<int> v[MAXN];
bool state = false;

void DFS(int i, int start)
{
    used[i] = 1;
    int sz = v[i].size();
    for(int j=0;j<sz;j++)
    {
        int nb = v[i][j];
        if(!used[nb])
        {
            used[nb] = 1;
            possible[start][nb] = 1;
            possible[nb][start] = 1;
            DFS(nb, start);
        }
    }
}

void perm(int pos)
{
    if(pos > k)
    {
        //print();
        for(int i=1;i<k;i++)
        {
            for(int j=i+1;j<=k;j++)
            {
                if(!possible[p[i]][p[j]]) return;
            }
        }
        state = true;
        return;
    }
    else
    {
        for(int i=1;i<=n;i++)
        {
            if(!used[i])
            {
                used[i] = 1;
                p[pos] = i;
                perm(pos+1);
                used[i] = 0;
            }
        }
    }
}

bool check()
{
    state = false;
    memset(used, 0, sizeof(used));
    memset(p, 0, sizeof(p));
    perm(1);
    return state;
}

int bin_search()
{
    int l = 1, r = n;
    while(l <= r)
    {
        k = (l+r)/2;
        if(check()) l = k+1;
        else r = k-1;
    }
    return r;
}

void read()
{
    int x, y;
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
    }
    for(int i=1;i<=n;i++)
    {
        DFS(i, i);
        memset(used, 0, sizeof(used));
    }
    cout<<bin_search()<<endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
    return 0;
}
