#include<bits/stdc++.h>
//#define endl '\n'

using namespace std;

int const MAXN=1000001;
int n, m, used[MAXN], x[MAXN], comp[MAXN], y[MAXN], idx, ans[MAXN], big[MAXN];
stack<int> st;
vector<int> v[MAXN], ver[MAXN];

void DFS(int i)
{
    used[i] = 1;
    int sz = v[i].size();
    for(int j=0;j<sz;j++)
    {
        int nb = v[i][j];
        if(!used[nb])
        {
            used[nb] = 1;
            DFS(nb);
        }
    }
    st.push(i);
}

void visit(int i)
{
    used[i] = 1;
    comp[i] = idx;
    big[idx]++;
    int sz = v[i].size();
    for(int j=0;j<sz;j++)
    {
        int nb = v[i][j];
        if(!used[nb])
        {
            visit(nb);
        }
    }
}

void DFS1(int i)
{
    used[i] = 1;
    int sz = ver[i].size();
    for(int j=0;j<sz;j++)
    {
        int nb = ver[i][j];
        if(!used[nb])
        {
            used[nb] = 1;
            DFS1(nb);
        }
        ans[i] = max(ans[i], ans[nb]+big[i]);
    }
}

void read()
{
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        cin>>x[i]>>y[i];
        v[x[i]].push_back(y[i]);
    }
    for(int i=1;i<=n;i++)
    {
        if(!used[i])
        {
            DFS(i);
        }
    }
    memset(used, 0, sizeof(used));
    for(int i=1;i<=n;i++)
    {
        v[i].clear();
    }
    for(int i=1;i<=m;i++)
    {
        v[y[i]].push_back(x[i]);
    }
    idx = 1;
    while(!st.empty())
    {
        if(!used[st.top()])
        {
            visit(st.top());
            idx++;
        }
        st.pop();
    }
    idx--;
    for(int i=1;i<=n;i++)
    {
        int sz = v[i].size();
        for(int j=0;j<sz;j++)
        {
            int nb = v[i][j];
            if(comp[i] != comp[nb])
            {
                ver[comp[i]].push_back(comp[nb]);
            }
        }
    }
    memset(used, 0, sizeof(used));
    for(int i=1;i<=idx;i++)
    {
        ans[i] = big[i];
    }
    for(int i=1;i<=idx;i++)
    {
        if(!used[i])
        {
            DFS1(i);
        }
    }
    int maxn = 0;
    for(int i=1;i<=idx;i++)
    {
        if(maxn < ans[i]) maxn = ans[i];
    }
    cout<<maxn<<endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
    return 0;
}
