#include<iostream>
#include<vector>
#include<algorithm>
#include "game.h"
using namespace std;
const int MAX_N=1e5+4;
const int LOG=20;
vector<int>g[MAX_N];
int par[MAX_N][LOG];
int child[MAX_N];
int dep[MAX_N];
int n;
int kud[MAX_N];
vector<pair<int,int>>ko;
void DFS(int u,int pa)
{
    for(int v:g[u])
    {
        if(v==pa)continue;
        dep[v]=dep[u]+1;
        DFS(v,u);
        par[v][0]=u;
        child[u]++;
    }
}
void Precompute()
{
    for(int j=1;j<LOG-1;j++)
    {
        for(int i=1;i<=n;i++)
        {
            par[i][j]=par[par[i][j-1]][j-1];
        }
    }
}
int kth(int u,int k)
{
    for(int j=LOG-2;j>=0;j--)
    {
        if((1<<j)<=k)
        {
            k-=(1<<j);
            u=par[u][j];
        }
    }
    return u;
}
int guess(int nn,int a[],int b[])
{
    n=nn;
    //cout<<n<<endl;
    for(int i=0;i<n-1;i++)
    {
        g[a[i]].push_back(b[i]);
        g[b[i]].push_back(a[i]);
    }
    DFS(1,0);
    Precompute();
    for(int i=1;i<=n;i++)
    {
        if(child[i]==0)
        {
            ko.push_back({-dep[i],i});
        }
    }
    sort(ko.begin(),ko.end());
    for(int ii=0;ii<ko.size();ii++)
    {
        int i=ko[ii].second;
        if(child[i]==0)
        {
            int l=0,r=dep[i];
            while(l<=r)
            {
                int mid=(l+r)/2;
                int ka=kth(i,mid);
                int cur=question(ka);
                if(cur!=par[ka][0])
                {
                    if(cur==ka)return cur;
                    r=mid-1;
                }
                else
                {
                    l=mid+1;
                }
            }
        }
    }

}
