#include<iostream>
#include<cmath>
#include<vector>
#include "game.h"
using namespace std;
const int MAXN = 1e5+7;
vector<int> susedi[MAXN];
int dulb[MAXN];
bool used[MAXN];
int depth(int vr){
    used[vr]=true;
    for(auto to:susedi[vr]){
        if(!used[to]) dulb[vr]+=depth(to);
    }
    dulb[vr]++;
    used[vr]=false;
    return dulb[vr];
}
int guess(int N,int a[],int b[]){
    for(int i=0;i<N-1;i++){
        susedi[a[i]].push_back(b[i]);
        susedi[b[i]].push_back(a[i]);
    }
    depth(1);
    int vr=1;
    bool fl;
    while(true){
        used[vr]=true;
        fl=true;
        for(auto to:susedi[vr]){
            //cout<<to<<" ";
            if(!used[to] and dulb[to]>N/2){
                vr=to;
                fl=false;
                break;
            }
        }
        //cout<<"\n";
        if(fl){
            break;
        }
    }
    //cout<<vr<<"\n";
    int predpologenie=question(vr);
    if(predpologenie!=vr){
        for(int i=1;i<=N;i++){
            used[i]=false;
        }
        used[vr]=true;
    }else{
        return vr;
    }
    vr=predpologenie;
    int razmer=N;
    while(true){
        razmer=depth(vr);
        while(true){
            used[vr]=true;
            fl=true;
            for(auto to:susedi[vr]){
                //cout<<to<<" ";
                if(!used[to] and dulb[to]>razmer/2){
                    vr=to;
                    fl=false;
                    break;
                }
            }
            //cout<<"\n";
            if(fl){
                break;
            }
        }
        //cout<<vr<<"\n";
        predpologenie=question(vr);
        if(vr!=predpologenie){
            used[vr]=true;
            vr=predpologenie;
            if(razmer==2){
                return predpologenie;
            }
        }else{
            return vr;
        }
    }
    return 1;
}
