#include<iostream>
#include<cmath>
#include<vector>
#include "game.h"
using namespace std;
const int MAXN = 1e5+7;
vector<int> v[MAXN];
int sz[MAXN];
bool vis[MAXN];
void dfs(int x,int p){
    sz[x]=1;
    for(int s:v[x]){
        if(s!=p and !vis[s]){
            dfs(s,x);
            sz[x]+=sz[s];
        }
    }
}
int centroid(int x,int p,int currsz){
    for(int s:v[x]){
        if(s!=p and !vis[s] and sz[s]>currsz/2){
            return centroid(s,x,currsz);
        }
    }
    return x;
}
int ans;
void solve(int x,int p,int currsz){
    dfs(x,0);
    int c=centroid(x,0,currsz);
    vis[c]=true;
    int predpologenie=question(c);
    if(predpologenie==c){
        ans = c;
        return;
    }
    //for(int s:v[c]){
        int s=predpologenie;
        if(!vis[s] and sz[s]<sz[c]){
            solve(s,c,sz[s]);
        }else if(!vis[s]){
            solve(s,c,currsz-sz[c]);
        }
    //}
}
int guess(int N,int a[],int b[]){
    for(int i=0;i<N-1;i++){
        v[a[i]].push_back(b[i]);
        v[b[i]].push_back(a[i]);
    }
    solve(1,0,N);
    return ans;
}

