#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn=1e5+5;
int n,m;
int a[maxn];
int whole[4*maxn],lefti[4*maxn],righti[4*maxn],small[4*maxn];
int ql,qr,val;

int make_whole(int v, int l, int r)
{
    l=v*2;
    r=v*2+1;
    return max(whole[l]+lefti[r],righti[l]+whole[r]);
}

int make_lefti(int v, int l, int r)
{
    l=v*2;
    r=v*2+1;
    return max(lefti[l]+lefti[r],small[l]+whole[r]);
}

int make_righti(int v, int l, int r)
{
    l=v*2;
    r=v*2+1;
    return max(righti[l]+righti[r],whole[l]+small[r]);
}

int make_small(int v, int l, int r)
{
    l=v*2;
    r=v*2+1;
    return max(small[l]+righti[r],lefti[l]+small[r]);
}

void make_tree(int v, int l, int r)
{
    if(l==r)
    {
        whole[v]=a[r];
        return;
    }
    int mid=(l+r)/2;
    make_tree(v*2+0,l,mid+0);
    make_tree(v*2+1,mid+1,r);
    whole[v]=make_whole(v,l,r);
    lefti[v]=make_lefti(v,l,r);
    righti[v]=make_righti(v,l,r);
    small[v]=make_small(v,l,r);
}

void update(int v, int l, int r)
{
    if(r<ql||qr<l||l>r) return;
    if(ql<=l&&r<=qr)
    {
        whole[v]=val;
        return;
    }
    int mid=(l+r)/2;
    update(v*2+0,l,mid+0);
    update(v*2+1,mid+1,r);
    whole[v]=make_whole(v,l,r);
    lefti[v]=make_lefti(v,l,r);
    righti[v]=make_righti(v,l,r);
    small[v]=make_small(v,l,r);
}

void read()
{
    cin >> n >> m;
    for(int i=1;i<=n;i++)
    {
        cin >> a[i];
    }
    make_tree(1,1,n);
    cout << whole[1] << endl;
    int b,t;
    for(int i=1;i<=m;i++)
    {
        cin >> b >> t;
        ql=qr=b;
        val=t;
        update(1,1,n);
        cout << whole[1] << endl;
    }
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
return 0;
}
