#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const long long maxn=1e5+5;
long long n,m;
long long a[maxn];
long long whole[4*maxn],lefti[4*maxn],righti[4*maxn],small[4*maxn];
long long ql,qr,val;

long long make_whole(long long v, long long l, long long r)
{
    l=v*2;
    r=v*2+1;
    return max(whole[l]+lefti[r],righti[l]+whole[r]);
}

long long make_lefti(long long v, long long l, long long r)
{
    l=v*2;
    r=v*2+1;
    return max(lefti[l]+lefti[r],small[l]+whole[r]);
}

long long make_righti(long long v, long long l, long long r)
{
    l=v*2;
    r=v*2+1;
    return max(righti[l]+righti[r],whole[l]+small[r]);
}

long long make_small(long long v, long long l, long long r)
{
    l=v*2;
    r=v*2+1;
    return max(small[l]+righti[r],lefti[l]+small[r]);
}

void make_tree(long long v, long long l, long long r)
{
    if(l==r)
    {
        whole[v]=a[r];
        return;
    }
    long long mid=(l+r)/2;
    make_tree(v*2+0,l,mid+0);
    make_tree(v*2+1,mid+1,r);
    whole[v]=make_whole(v,l,r);
    lefti[v]=make_lefti(v,l,r);
    righti[v]=make_righti(v,l,r);
    small[v]=make_small(v,l,r);
}

void update(long long v, long long l, long long r)
{
    if(r<ql||qr<l||l>r) return;
    if(ql<=l&&r<=qr)
    {
        whole[v]=val;
        return;
    }
    long long mid=(l+r)/2;
    update(v*2+0,l,mid+0);
    update(v*2+1,mid+1,r);
    whole[v]=make_whole(v,l,r);
    lefti[v]=make_lefti(v,l,r);
    righti[v]=make_righti(v,l,r);
    small[v]=make_small(v,l,r);
}

void read()
{
    cin >> n >> m;
    for(long long i=1;i<=n;i++)
    {
        cin >> a[i];
    }
    make_tree(1,1,n);
    cout << whole[1] << endl;
    long long b,t;
    for(long long i=1;i<=m;i++)
    {
        cin >> b >> t;
        ql=qr=b;
        val=t;
        update(1,1,n);
        cout << whole[1] << endl;
    }
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
return 0;
}
