#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

struct Point
{
    int x,y;
    Point(){};
    Point(int xi, int yi)
    {
        x=xi;
        y=yi;
    }
};

const int maxn=1e5+5;
int n,m,k;
int used[maxn],used2[maxn],used3[maxn],comp[maxn],br[maxn],dp[maxn];
vector<int>v[maxn],r[maxn],g[maxn];
stack<int>s1;
vector<Point> sp;
int ans;

void read()
{
    cin >> n >> m;
    int ql,qr;
    for(int i=1;i<=m;i++)
    {
        cin >> ql >> qr;
        sp.push_back({ql,qr});
        v[ql].push_back(qr);
        r[qr].push_back(ql);
    }
}

void dfs(int beg)
{
    used[beg]=1;
    int nb,sz;
    sz=v[beg].size();
    for(int i=0;i<sz;i++)
    {
        nb=v[beg][i];
        if(!used[nb]) dfs(nb);
    }
    s1.push(beg);
}

void top_sort()
{
    for(int i=1;i<=n;i++)
    {
        if(!used[i]) dfs(i);
    }
}

void scc(int beg)
{
    used2[beg]=1;
    comp[beg]=k;
    br[k]++;
    int nb,sz;
    sz=r[beg].size();
    for(int i=0;i<sz;i++)
    {
        nb=r[beg][i];
        if(!used2[nb]) scc(nb);
    }
}

void DFS(int beg)
{
    used3[beg]=1;
    dp[beg]=br[beg];
    int sz,nb;
    sz=g[beg].size();
    int chis=0;
    for(int i=0;i<sz;i++)
    {
        nb=g[beg][i];
        if(!used3[nb]) DFS(nb);
        chis=max(chis,dp[nb]);
    }
    dp[beg]+=chis;
    ans=max(ans,dp[beg]);
}

void solve()
{
    top_sort();
    int ch;
    while(!s1.empty())
    {
        ch=s1.top();
        if(!used2[ch])
        {
            k++;
            scc(ch);
        }
        s1.pop();
    }
    Point nb;
    int ql,qr;
    for(int i=0;i<m;i++)
    {
        nb=sp[i];
        ql=nb.x;
        qr=nb.y;
        if(comp[ql]!=comp[qr]) g[comp[ql]].push_back(comp[qr]);
    }
    for(int i=1;i<=k;i++)
    {
        if(!used3[i]) DFS(i);
    }
    cout << ans << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
	solve();
return 0;
}
