#include <bits/stdc++.h>
#define endl '\n'
#include "game.h"

using namespace std;

const int maxn = 1e5 + 10;
int dp[maxn], used[maxn];
vector<int> v[maxn], g[maxn];

void dfs(int ver){
    used[ver] = 1;
    if(!v[ver].size()){
        dp[ver] = 1;
        return;
    }
    for(int nb : v[ver]){
        if(!used[nb]){
            dfs(nb);
            g[ver].push_back(nb);
            dp[ver] = dp[nb] + 1;
        }
    }
}
void DFS(int ver){
    for(int nb : g[ver]){
        dp[nb] = dp[ver] - 1;
        DFS(nb);
    }
}

int guess(int N, int a[], int b[]){
    for(int i = 0;i <= N - 2;i++){
        v[a[i]].push_back(b[i]);
        v[b[i]].push_back(a[i]);
    }
    dfs(1);
    DFS(1);
    int l = 1, r = N;
    while(l <= r){
        int mid = (l + r) / 2;
        int ver = question(mid);
        if(ver == mid) return ver;
        if(dp[ver] > dp[mid]) r = mid - 1;
        else l = mid + 1;
    }
}
