#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e5;
int n, m, used[maxn], ans, cnt;
vector<int> v[maxn], nb[maxn];
stack<int> s;

void dfs(int x){
    used[x] = 1;
    for(int nb : v[x]){
        if(!used[nb]) dfs(nb);
    }
    s.push(x);
}

void scc(int x){
    used[x] = 1; cnt++;

    ans = max(ans, cnt);
    for(int nb : v[x]){
        if(!used[nb]) scc(nb);
    }
}

void solve(){
    for(int i = 1;i <= n;i++){
        if(!used[i]) dfs(i);
    }
    for(int i = 1;i <= n;i++){
        for(int x : v[i]){
            nb[x].push_back(i);
        }
    }
    for(int i = 1;i <= n;i++){
        v[i] = nb[i];
    }
    memset(used, 0, sizeof(used));
    int k = 0;
    while(!s.empty()){
        int ver = s.top(); s.pop(); cnt = 0;
        if(!used[ver]){
            scc(ver); ++k;
        }
    }
    cout << k + ans - 1 << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for(int i = 1;i <= m;i++){
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
    }
    solve();
    return 0;
}
