#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e6 + 10;
int n, m, used[maxn], cnt, sz[maxn];
vector<int> v[maxn], nb[maxn], g[maxn];
stack<int> s;
long long dp[maxn];

void dfs(int x){
    used[x] = 1;
    for(int nb : v[x]){
        if(!used[nb]) dfs(nb);
    }
    s.push(x);
}

void scc(int x, int k){
    used[x] = k; cnt++;
    sz[k]++;
    for(int nb : v[x]){
        if(!used[nb]) scc(nb, k);
    }
}

void DFS(int ver){
    used[ver] = 1;
    if(!g[ver].size()){
        dp[ver] = sz[ver];
        return;
    }
    long long ans = 0;
    for(int nb : g[ver]){
        if(!used[nb]) DFS(nb);
        ans = max(ans, dp[nb]);
    }
    dp[ver] = ans + sz[ver];
}

void solve(){
    for(int i = 1;i <= n;i++){
        if(!used[i]) dfs(i);
    }
    memset(used, 0, sizeof(used));
    for(int i = 1;i <= n;i++){
        for(int x : v[i]){
            nb[x].push_back(i);
        }
    }
    for(int i = 1;i <= n;i++){
        v[i] = nb[i];
    }
    int k = 1;
    while(!s.empty()){
        int ver = s.top(); s.pop();
        if(!used[ver]){
            scc(ver, k); ++k;
        }
    }
    for(int i = 1;i <= n;i++){
        for(int x : v[i]){
            if(used[i] != used[x]){
                g[used[i]].push_back(used[x]);
            }
        }
    }
    memset(used, 0, sizeof(used));
    for(int i = 1;i <= n;i++){
        if(!used[i]) DFS(i);
    }
    long long ans = 0;
    for(int i = 1;i <= n;i++){
        ans = max(ans, dp[i]);
    }
    cout << ans << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for(int i = 1;i <= m;i++){
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
    }
    solve();
    return 0;
}
