#include <bits/stdc++.h>
using namespace std;

int n, m;
const int MAXN = 1e5+1;
int a[MAXN];
struct Tel{
    Tel *ld, *rd;
    int whole, left, right, small;
    int l, r;
};

void Build(Tel* k) {
    if(k->l == k->r) {
        k->whole = a[k->l];
        k->left = 0; k->right = 0;
        k->small = 0;
        return;
    }

    k->ld = new Tel;
    k->ld->l = k->l;  k->ld->r = (k->l + k->r)/2;
    Build(k->ld);
    k->rd = new Tel;
    k->rd->l = (k->l + k->r)/2+1;  k->rd->r = k->r;
    Build(k->rd);

    k->whole = max(k->ld->whole + k->rd->left, k->ld->right + k->rd->whole);
    k->left = max(k->ld->left + k->rd->left, k->ld->small + k->rd->whole);
    k->right = max(k->ld->whole + k->rd->small, k->ld->right + k->rd->right);
    k->small = max(k->ld->small + k->rd->right, k->ld->left + k->rd->small);
}

void Update(Tel* k, int p) {
    if(k->l > p || k->r < p) return;
    if(k->l == k->r) {
        k->whole = a[k->l];
        return;
    }

    Update(k->ld, p);
    Update(k->rd, p);

    k->whole = max(k->ld->whole + k->rd->left, k->ld->right + k->rd->whole);
    k->left = max(k->ld->left + k->rd->left, k->ld->small + k->rd->whole);
    k->right = max(k->ld->whole + k->rd->small, k->ld->right + k->rd->right);
    k->small = max(k->ld->small + k->rd->right, k->ld->left + k->rd->small);
}

int main()
{
    cin>>n>>m;
    int i;
    for(i=1;i<=n;i++) cin>>a[i];

    Tel *root = new Tel;
    root->l = 1;  root->r = n;
    Build(root);

    cout<<root->whole<<endl;

    while(m--) {
        int p, q;
        cin>>p>>q;
        a[p] = q;
        Update(root, p);
        cout<<root->whole<<endl;
    }


    return 0;
}
